#ModelSwarm.py
import Tools
from Agent import *
from WorldState import *
from ActionGroup import *
import random
import os
from mActions import *
from turtle import *

task="0 0".split()

class ModelSwarm:
    def __init__(self, nAgents, worldXSize, worldYSize, project0):
        global task, project
        project=project0

        # the environment
        task="0 0".split() #in case of repeated execution without restarting the shell 
        self.ff="" #in case of repeated execution without restarting the shell
        self.nAgents = nAgents
        self.agentList = []
        self.worldStateList=[]

        self.worldXSize= worldXSize
        self.worldYSize= worldYSize

        agTypeFile=open("./"+project+"/agTypeFile.txt","r")
        self.share=0
        self.types=agTypeFile.read().split()
        agTypeFile.close()
        #print self.types

        dictExe={}
        dictExe["project"]=project
        execfile("convert_xls_txt.py",dictExe)

    # objects
    def buildObjects(self):
        for i in range(1):
            aWorldState = WorldState(i)
            self.worldStateList.append(aWorldState)

        leftX =int(-self.worldXSize/2)
        rightX=int(self.worldXSize-1 -self.worldXSize/2) 
        leftY =int(-self.worldYSize/2)
        rightY=int(self.worldYSize-1 -self.worldYSize/2) 

        # internal agents
        for i in range(self.nAgents):
            anAgent = Agent(i, self.worldStateList[0],
                    random.randint(leftX,rightX), 
                    random.randint(leftY,rightY), leftX,rightX,
                    leftY,rightY,agType="bland")
            self.agentList.append(anAgent)
        print

        # external agents
        files=os.listdir("./"+project)

        for agType in self.types:
            if not agType+".txt" in files: print "No", agType,\
               "agents: lacking the specific file", agType+".txt"
        print

        for agType in self.types:
         if agType+".txt" in files:
           f=open("./"+project+"/"+agType+".txt","r")
           for line in f:
               num=int(line.split()[0])
               print "creating "+agType+" agent #", num


               if len(line.split())==4 and line.split()[1] != 'static':
                anAgent = Agent(num, self.worldStateList[0],
                         int(line.split()[2]), 
                         int(line.split()[3]),
                         leftX,rightX,leftY,rightY,agType=agType)
                self.agentList.append(anAgent)
                anAgent.setColor(line.split()[1])
                   
               elif len(line.split())==4 and line.split()[1] == 'static':
                anAgent = Agent(num, self.worldStateList[0],
                         int(line.split()[2]), 
                         int(line.split()[3]),
                         leftX,rightX,leftY,rightY,agType=agType)
                #self.agentList.append(anAgent)
                anAgent.setColor("brown")

               else: 
                anAgent = Agent(num, self.worldStateList[0],
                         random.randint(leftX,rightX), 
                         random.randint(leftY,rightY),
                         leftX,rightX,leftY,rightY,agType=agType)
                self.agentList.append(anAgent)

           f.close()
           print
            

    # actions
    def buildActions(self): 

        modelActions=open("./"+project+"/modelActions.txt")
        mList=modelActions.read().split()
        modelActions.close()

        self.actionList = mList
        #print self.actionList

        # look at basic case schedule, where "move" represents an example of mandatory
        # action (in our case generating also a dynamic "jump" action) and
        # "read_script" represents an external source of actions
        # or, without reading the external schedule (anyway, in the case
        # above, if you do not put a schedule.txt or a schedule.xls file in
        # program folder, the "read_script" step simply has no effect)

        # basic actionGroup
        
        self.actionGroup0 = ActionGroup (self.actionList[0])
        self.actionGroup0.do = do0 # do is a variable linking a method

        self.actionGroup1 = ActionGroup (self.actionList[1])
        self.actionGroup1.do = do1 # do is a variable linking a method

        # to create other actionGroup ..,
        #self.actionGroup2 = ActionGroup (self.actionList[?])
        #self.actionGroup2.do = do2 # do is a variable linking a method
        # etc.

        # this actionGroup is the schedule, which is generalized
        # so it is not moved in the actions.py specific to the project
        # the task number is huge (100), considering it to be the last one
        # the name is identified as the last one, with -1
        self.actionGroup100 = ActionGroup (self.actionList[-1]) # the last
        def do100(address, cycle):
            global task

            actionDictionary[self.actionGroup100.getName()]=self.actionGroup100

            while True:
                if task[0]=="#":
                    if int(task[1]) > cycle: break

                task=read_s(self.ff)
                #print "***", task

                if task[0]=="#":
                    if int(task[1]) > cycle: break
                if task[0]=="0": break

                #if task[0].find('Agent')>=0:
                if check(task[0],self.types):
                    # keep safe the original list
                    localList=[]
                    for ag in address.agentList:
                        if   task[0]=="all": localList.append(ag)
                        elif task[0]==ag.getAgType(): localList.append(ag)
                    # never in the same order (please comment if you want to keep
                    # always the same sequence
                    random.shuffle(localList)
                    # apply method only to a share of the list
                    self.share=0
                    try:    self.share = float(task[1]) # does task[1] contains
                                                        # a number?
                    except: pass
                    
                    if self.share > 0:
                        tmpList=localList[:]
                        del localList[:]
                        for i in range(len(tmpList)):
                            if random.random() <= self.share:
                                localList.append(tmpList[i])
                    # apply
                    if len(localList)>0:
                        self.applyFromSchedule(localList,task)

                if task[0]=='WorldState':
                    self.share=0
                    localList=address.worldStateList[:]
                    self.applyFromSchedule(localList,task)
                   
        self.actionGroup100.do = do100 # do is a variable linking a method
    
    



    # run a step
    def step(self,cycle):
            global task

            step=self.actionList[:]

            while len(step)>0:
                subStep=extractASubStep(step)


                if subStep == self.actionList[0]:
                        self.actionGroup0.do(self)
                if subStep == self.actionList[1]:
                        self.actionGroup1.do(self)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable
                    

                # external schedule, in pos. -1
                if subStep == self.actionList[-1]:
                        if self.ff=="":
                            try: self.ff=open("./"+project+"/schedule.txt","r")
                            except: pass
                        self.actionGroup100.do(self,cycle)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable


    # from external schedule (script)
    def applyFromSchedule(self,localList,task):


        if task[0]=='WorldState':
            if task[2]=='setGeneralMovingProb':
                prob = 1
                try:  prob = float(task[1]) # does task[1] contains
                                            # a number?
                except: pass
            d={}
            d['generalMovingProb']=prob
            exec "askEachAgentIn(localList,"+task[0]+"."+task[2]+", **d)"    


        #if task[0].find('Agent')>=0:
        if check(task[0],self.types):
            if self.share>0:
                exec "askEachAgentIn(localList,Agent"+"."+task[2]+")"
            else:
                exec "askEachAgentIn(localList,Agent"+"."+task[1]+")" 

    # agent list
    def getAgentList(self):
        return self.agentList

    # file address
    def getFile(self):
        return self.ff

# tools, read_s
def read_s(f):
    if f != "":
        try:
            task=f.readline()
            if task=='':task='0 0'
        except:
            task='0 0'
    else: task='0 0'

    return task.split()

# check if it is an agent
def check(s,aList):
    found=False
    if s.find("all")==0  : found=True
    if s.find("bland")==0: found=True
    for name in aList:
        if s.find(name)==0:found=True
    return found
