#Agent.py
from Tools import *
from turtle import *

register_shape("school/pupilBlue.gif")
register_shape("school/pupilGreen.gif")
register_shape("school/pupilRed.gif")
register_shape("desk",((5,-15),(15,-15),(15,15),(5,15)))

class Agent(Turtle):
    def __init__(self, number,myWorldState,
                 xPos, yPos, lX =-20,rX=19, lY=-20,rY=19, agType=""):
        Turtle.__init__(self)
        
        # the environment
        self.number = number
        self.lX = lX
        self.rX = rX
        self.lY = lY
        self.rY = rY
        self.myWorldState = myWorldState
        self.agType=agType
        # the agent
        self.xPos = xPos
        self.yPos = yPos
        print "agent", self.agType, "#", self.number, \
     	      "has been created at", self.xPos, ",", self.yPos

        # turtle behavior
        self.speed(0)
        self.penup()
        self.color("black")
        self.setx(self.xPos*1)
        self.sety(self.yPos*1)

        self.attention=0

    def setColor(self,color):
        self.color(color)
        if color=="blue" : self.shape("school/pupilBlue.gif")
        if color=="green": self.shape("school/pupilGreen.gif")
        if color=="red"  : self.shape("school/pupilRed.gif")
        if color=="brown": self.shape("desk")

    # reset values
    def setNewCycleValues(self):
        self.attention=0.5

    # attention
    def getAttention(self):
        return self.attention
        

    # ",**d" in the parameter lists of the methods is a place holder
    # in case we use, calling the method, a dictionary as last par

    # talking (to be developed)
    def talk(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "Ciao!"
        self.attention-=0.5

        self.write("Ciao", font=("Arial", 14)) # turtle action

    # asking
    def ask(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm asking something!"
        self.attention+=0.5


        self.write("Asking!!!", font=("Arial", 14)) # turtle action


    # the action, also jumping
    def randomMovement(self,**k):
        if random.random()<=self.myWorldState.getGeneralMovingProb():
            print "%s agent # %d moving" % (self.agType,self.number)
            self.jump=k["jump"]
            dx=randomMove(self.jump)
            self.xPos +=dx
            dy=randomMove(self.jump)
            self.yPos += dy
            #self.xPos = (self.xPos + self.worldXSize) % self.worldXSize
            #self.yPos = (self.yPos + self.worldYSize) % self.worldYSize
            if self.xPos < self.lX : self.xPos=self.lX
            if self.xPos > self.rX : self.xPos=self.rX
            if self.yPos < self.lY : self.yPos=self.lY
            if self.yPos > self.rY : self.yPos=self.rY

            self.attention-=0.25

            if abs(dx) > 4 and abs(dy) > 4 :
                self.attention-=0.25
    
            # modify actionGroup "move"
                actionGroup=actionDictionary.get("move","none")
                                    # in case, return "none"
        
                if actionGroup=="none": print "warning, actionGroup not found "+\
                                "in agent "+ str(self.number)
            
                else:
                    actionGroup.setLocalCode(actionGroup.getLocalCode()+\
                                "print 'agent %s # %d made a big jump';" \
                                             % (self.agType,self.number))
                    self.write("I jumped",font=("Arial", 14)) # acting as a turtle

        # tutle reports
        #self.clear()
        self.setx(self.xPos*1)
        self.sety(self.yPos*1)

    # report
    def reportPosition(self,**d):
        print self.agType, "#", self.number, "is at X =", \
               self.xPos, " Y =", self.yPos

    def getAgType(self):
        return self.agType

    # methods for Tk graphic applications
    def getXPos(self):
        return self.xPos

    def getYPos(self):
        return self.yPos

    def setGraphicItem(self, grI):
        self.graphicItem=grI

    def getGraphicItem(self):
        return self.graphicItem

# returns -1, 0, 1  with equal probability
def randomMove(jump):
    return random.randint(-1, 1)*jump
